Index: init.php
===================================================================
--- init.php	2011-06-09 11:21:27.000000000 +0400
+++ init.php	2011-06-09 11:18:58.000000000 +0400
@@ -1079,22 +1079,34 @@
 }
 
 if ($active_modules) {
-    // Load functions for module (run include "modules/<module_name>/func.php")
-    $include_func = true;
+    if ($config['General']['use_new_module_initialization'] != 'Y') {
+        $include_func = $include_init = false;
+    } else {
+        // Load functions for module (run include "modules/<module_name>/func.php")
+        $include_func = true;
 
-    // Init modules (run include "modules/<module_name>/init.php")
-    $include_init = true; 
+        // Init modules (run include "modules/<module_name>/init.php")
+        $include_init = true; 
+    }
 
     $_active_modules = $active_modules;
     foreach ($_active_modules as $active_module => $tmp) {
 
         $_module_dir  = $xcart_dir . XC_DS . 'modules' . XC_DS . $active_module;
         $_config_file = $_module_dir . XC_DS . 'config.php';
+        $_func_file   = $_module_dir . XC_DS . 'func.php';
 
         if (is_readable($_config_file)) {
             include $_config_file;
         }
 
+        if (
+            $config['General']['use_new_module_initialization'] != 'Y'
+            && is_readable($_func_file)
+        ) {
+            require_once $_func_file;
+        }
+
     }
     unset($include_func, $include_init, $_active_modules);
 }
@@ -1188,6 +1200,27 @@
 }
 
 /**
+ * Init modules. Used in all module initialization schema
+ */
+if (
+    $config['General']['use_new_module_initialization'] != 'Y'
+    && is_array($active_modules)
+) {
+    $_active_modules = $active_modules;
+
+    foreach ($_active_modules as $__k => $__v) {
+
+        if (is_readable($xcart_dir . '/modules/' . $__k . '/init.php')) {
+
+            include $xcart_dir . '/modules/' . $__k . '/init.php';
+
+        }
+    }
+    unset($_active_modules);
+}
+
+
+/**
  * Session-based cron
  */
 if (!defined('QUICK_START') && defined('NEW_SESSION')) {
